import { _decorator, Component, Label, Node } from 'cc';
import { app, JNGLayerBase } from '../../App';
import { Toggle } from 'cc';
import { JNSyncAction } from '../../../../extensions/ngame/assets/ngame/sync/JNSyncAction';
import { director } from 'cc';
import { WorldCanvas } from '../../WorldCanvas';
const { ccclass, property } = _decorator;

@ccclass('HomeView')
export class HomeView extends JNGLayerBase {

    @property(Label)
    frameText:Label;

    update(){
        this.frameText.string = `当前帧数: ${app.sync.frame}`;
    }

    //设置移动
    setRoleMove(data:Toggle){
        console.log("移动",data.isChecked);
    }

    //设置攻击
    setRoleAttack(data){
        console.log("攻击",data.isChecked);
    }

    //重置
    onClickReset(){
        app.sync.onReset();
    }

    //重置服务器帧
    onClickResetServer(){
        app.socket.Send(JNSyncAction.NSyncFrameReset);
    }

    //前往PVP
    onClickGoPVP(){
        director.getScene().getComponentInChildren(WorldCanvas).index = 0;
    }
    //前往无尽
    onClickGoOnHook(){
        director.getScene().getComponentInChildren(WorldCanvas).index = 1;
    }

}


