import { v3 } from "cc";
import { JNLayerAnim, JNLayerInfo } from "../../../extensions/ngame/assets/ngame/ui/JNLayer";

export enum GLayer{
    View = "View",
}

export enum GUI{
    Loading = "Loading",
    Home = "Home",
}

export const UIConfig:{ [key: string]: JNLayerInfo; } = {
    [GUI.Loading]:{ 
        layer:GLayer.View, 
        uri: "prefab/ui/Loading/LoadingView",
        anims:{
            back:JNLayerAnim.Smaller,
            backInfo:{key:"position",start:v3(0,0,0),end:v3(-720,0,0)}
        },
    },
    [GUI.Home]:{ 
        layer:GLayer.View,
        uri: "prefab/ui/Home/HomeView",
        anims:{
            front:JNLayerAnim.Enlarge,
            back:JNLayerAnim.Smaller,
            frontInfo:{key:"position",start:v3(720,0,0),end:v3(0,0,0)},
            backInfo:{key:"position",start:v3(0,0,0),end:v3(-720,0,0)}
        },
    },
}

