package cn.jisol.game.listener;

import cfg.Tables;
import cn.jisol.game.data.TD;
import com.google.gson.JsonParser;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.util.ResourceUtils;

import java.io.FileReader;
import java.io.IOException;

@Component
public class InitGameListener {

    @EventListener(ContextRefreshedEvent.class)
    public void onApplicationEvent(ContextRefreshedEvent event) {

        try {
            TD.DATA = new Tables(file -> {
                System.out.println("加载配置表:"+file);
                return JsonParser.parseReader(
                        new FileReader(ResourceUtils.getFile("classpath:json/"+file+".json"))
                );
            });
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

}
